<?php
namespace app\models;

use app\app;
use PDO; // Added PDO class import

class user_addresses
{
    public static function init()
    {
        app::$db->exec("CREATE TABLE IF NOT EXISTS user_addresses (
            user_id INTEGER NOT NULL,
            address_id INTEGER NOT NULL,
            PRIMARY KEY (user_id, address_id),
            FOREIGN KEY (address_id) REFERENCES addresses(id)
        )");
    }

    public static function getShippingByUserId($id)
    {
        $query = "SELECT a.* FROM users u
          JOIN user_addresses ua ON u.id = ua.user_id
          JOIN addresses a ON ua.address_id = a.id
          WHERE u.id = :id AND a.shipping = 1";
        $stmt = app::$db->prepare($query);
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $addrs = $stmt->fetch(\PDO::FETCH_ASSOC);
        return [$addrs];
    }
    
    public static function getBillingByUserId($id)
    {
        $query = "SELECT a.* FROM users u
          JOIN user_addresses ua ON u.id = ua.user_id
          JOIN addresses a ON ua.address_id = a.id
          WHERE u.id = :id AND a.billing = 1";
        $stmt = app::$db->prepare($query);
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $addrs = $stmt->fetch(\PDO::FETCH_ASSOC);
        return [$addrs];
    }

    public static function add($user_id, $address_id)
    {
        $query = "INSERT INTO user_addresses (
            user_id, 
            address_id
        ) VALUES (
            :user_id, 
            :address_id
        )";
        $stmt = app::$db->prepare($query);
        $stmt->bindParam(':user_id', $user_id);
        $stmt->bindParam(':address_id', $address_id);
        $stmt->execute();
        return app::$db->lastInsertId();
    }

}
