<?php
//
// Use this to initialize the database models
// Run it in command-line like
// php scripts/init_db.php
//
require_once __DIR__ . '/../../vendor/autoload.php';

// Load environment variables from the .env file at project root
Dotenv\Dotenv::createImmutable(__DIR__ . '/../../')->load();

// establish the db connection
use app\app;
app::init_db();

// db models go brrr...
use app\models\addresses;
addresses::init();

use app\models\cart_items;
cart_items::init();

use app\models\carts;
carts::init();

use app\models\emails;
emails::init();

use app\models\invoices;
invoices::init();

use app\models\magic_links;
magic_links::init();

use app\models\order_items;
order_items::init();

use app\models\orders;
orders::init();

use app\models\products;
products::init();

use app\models\quote_items;
quote_items::init();

use app\models\quotes;
quotes::init();

use app\models\subscriptions;
subscriptions::init();

use app\models\transactions;
transactions::init();

use app\models\user_addresses;
user_addresses::init();

use app\models\users;
users::init();
